
' construct perpendiculars to all selected polylines
' perpendiculars constructed to intersect at centroids

sub main
   dim pol1 as Polyline = new Polyline()
   dim l as Layer = doc.ActiveLayer()

   dim x as double = 0      ' polyline coordinate
   dim y as double = 0      ' polyline coordinate
   dim z as double = 0      ' polyline coordinate

   dim cp as Point3F
   dim cp2 as Point3F

   if view.SelectedEntities.Length > 0 then
      for each ent as Entity in view.SelectedEntities
         cp=ent.GetCentroid()
                   pol1=ent.Clone()
         l.Entities.Add(pol1)
         pol1.Transform.RotZ(Math.PI/2f)
         if pol1.ApplyTransformation() then
              pol1.Transform = Matrix4x4F.Identity
         end if
         cp2=pol1.GetCentroid()
         x=cp.x-cp2.x
         y=cp.y-cp2.y
         z=cp.z-cp2.z
         pol1.Transform.Translate(x,y,z)
               
         '// Repaint the view
         view.RefreshView()
      next ent
   end if
end sub